# $Date: 1996/07/02 12:37:23 $ $Author: zimmerma $ $Revision: 1.3 $ #

#--
	sinh/Series -- the function attribut "series" for sinh
--#

sinh:=funcattr(sinh,"series",proc(f,x,n)
   local t,k,a;
   name Series::sinh;
begin
   if f=x then Puiseux::create(1,1,n,Series::gen["sinh"](n),x)
   else
      t:=Series::Puiseux(f,x,n);
      k:=ldegree(t);
      if k>0 then Puiseux::_fconcat(
          Puiseux::create(1,1,n,Series::gen["sinh"](n),x),t)
      elif k=0 then
         a:=lcoeff(t);
         t:=f-a;
         sinh(a)*series(cosh(t),x,n)+cosh(a)*series(sinh(t),x,n)
      else error("unable to compute series expansion")
      end_if
   end_if
end_proc):

Series::gen["sinh"]:=proc(n) local i,t; # 0.9s pour n=100 #
begin
   t:=1;
   [1,(0,(t:=t/(2*i)/(2*i+1)))$i=1..(n-2) div 2]
end_proc:
Series::gen["sinh"](0):=[]:
Series::gen["sinh"](1):=[]:

# end of file #
